// ChaneNoticeDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "ChangeNoticeDlg.h"
#include "ChangeNoticeController.h"
#include "ChangeNoticeDialogManager.h"

// ChangeNoticeDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(ChangeNoticeDlg, CDialog)

ChangeNoticeDlg::ChangeNoticeDlg(CWnd* pParent /*=NULL*/)
: CDialog(ChangeNoticeDlg::IDD, pParent)
{
    m_changeType = CHANGETYPE_CHC01;
	LoadBitmapFromPath(m_bmIcon[0],GetAppImgFile( _T("icon_notice20_b.bmp")));
	LoadBitmapFromPath(m_bmIcon[1], GetAppImgFile(_T("icon_notice20_y.bmp")));
	LoadBitmapFromPath(m_bmIcon[2], GetAppImgFile(_T("icon_notice20_r.bmp")));
}

ChangeNoticeDlg::~ChangeNoticeDlg()
{
}

void ChangeNoticeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_OK, m_btnOk);
}


BEGIN_MESSAGE_MAP(ChangeNoticeDlg, CDialog)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_BUTTON_OK, &ChangeNoticeDlg::OnBnClickedButtonOk)
END_MESSAGE_MAP()



BOOL ChangeNoticeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitSkin();	

	MoveWindow(0, 0, CHANGENOTICE_DLG_SIZE_WIDTH, CHANGENOTICE_DLG_SIZE_HEIGHT);
	CenterWindow();


	if(m_changeType == CHANGETYPE_CHC01 ) //
		SetWindowText(LoadStringFromResource(IDS_STRING616));
	else if(m_changeType == CHANGETYPE_CHC02)
		SetWindowText(LoadStringFromResource(IDS_STRING617));
	else 
		SetWindowText(LoadStringFromResource(IDS_STRING618));

	if ( GetStyle() & WS_MINIMIZE )
	{
		ShowWindow( SW_SHOWNOACTIVATE);
		UpdateWindow();
	}

	HWND hWndForeground = ::GetForegroundWindow();
	if(hWndForeground == this->m_hWnd) return TRUE;

	DWORD Strange = ::GetWindowThreadProcessId(hWndForeground, NULL);
	DWORD My = ::GetWindowThreadProcessId(this->m_hWnd, NULL);
	::AttachThreadInput(Strange, My, TRUE);
	::SetForegroundWindow(this->m_hWnd);
	::BringWindowToTop(this->m_hWnd);
	::SetFocus(this->m_hWnd);
	::AttachThreadInput(Strange, My, FALSE); 
	m_btnOk.SetWindowText(LoadStringFromResource(IDS_STRING568));

	return TRUE;  
}

BOOL ChangeNoticeDlg::OnEraseBkgnd(CDC* pDC)
{
	CBitmap* bmIcon;
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);
	pDC->FillSolidRect(rcClient,CHANGENOTICE_DLG_BG_COLOR);
	pDC->FillSolidRect(0,0,CHANGENOTICE_DLG_SIZE_WIDTH,CHANGENOTICE_DLG_BORDER_PIXEL,CHANGENOTICE_DLG_CONTROL_BORDER_COLOR);
	pDC->FillSolidRect(0,322 ,CHANGENOTICE_DLG_SIZE_WIDTH,CHANGENOTICE_DLG_BORDER_PIXEL,CHANGENOTICE_DLG_CONTROL_BORDER_COLOR);

	CRect rcTitle(0, 0, 0, 0);
	rcTitle.SetRect(50,30,300,50);
	pDC->SetBkMode(TRANSPARENT);
	CFont *pOldFont = pDC->SelectObject(&g_ftDefault13PXB);
	COLORREF oldColor = pDC->SetTextColor(CHANGENOTICE_DLG_EDIT_FONT_COLOR);
	if(m_changeType == CHANGETYPE_CHC01 ) //
	{
		pDC->DrawText(LoadStringFromResource(IDS_STRING626), rcTitle, DT_LEFT);
		bmIcon = &m_bmIcon[0];
	}
	else if(m_changeType == CHANGETYPE_CHC02)
	{
		pDC->DrawText(LoadStringFromResource(IDS_STRING627), rcTitle, DT_LEFT);
		bmIcon = &m_bmIcon[1];
	}
	else 
	{
		pDC->DrawText(LoadStringFromResource(IDS_STRING628), rcTitle, DT_LEFT);
		bmIcon = &m_bmIcon[2];
	}

	CRect rcContent(0, 0, 0, 0);
	rcContent.SetRect(20, 60, 355, 92);

	pDC->SelectObject(&g_ftDefault13PX);
	pDC->SetTextColor(CHANGENOTICE_DLG_EDIT_FONT_COLOR);
	if(m_changeType== CHANGETYPE_CHC01 ) //
		pDC->DrawText(LoadStringFromResource(IDS_STRING629), rcContent, DT_LEFT);
	else if(m_changeType == CHANGETYPE_CHC02)
		pDC->DrawText(LoadStringFromResource(IDS_STRING630), rcContent, DT_LEFT);
	else 
		pDC->DrawText(LoadStringFromResource(IDS_STRING631), rcContent, DT_LEFT);
	
	CRect rcCheck(0, 0, 0, 0);
	rcCheck.SetRect(20 ,114,355, 194);
	pDC->SelectObject(&g_ftDefault13PXB);
	pDC->SetTextColor(CHANGENOTICE_DLG_EDIT_FONT_COLOR);

	CString strNotice;
	CString strStartTime;
	CString strEndTime;
	CString strReason;
	strNotice.Format(L"%s\n" ,LoadStringFromResource(IDS_STRING623));

	
	strStartTime.Format(LoadStringFromResource(IDS_STRING624), m_CheckStartTime.GetYear(), m_CheckStartTime.GetMonth(), m_CheckStartTime.GetDay(), CTimeConversion::GetStringDayOfWeek(m_CheckStartTime) ,m_CheckStartTime.GetHour(), m_CheckStartTime.GetMinute() );

	strEndTime.Format(LoadStringFromResource(IDS_STRING624), m_CheckEndTime.GetYear(), m_CheckEndTime.GetMonth(), m_CheckEndTime.GetDay(), CTimeConversion::GetStringDayOfWeek(m_CheckEndTime), m_CheckEndTime.GetHour(), m_CheckEndTime.GetMinute() );



	if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{
		strReason = strReasonKR;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{
		strReason = strReasonEN;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
		strReason = strReasonJP;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
		strReason = strReasonCN;
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
		strReason = strReasonTW;
	}


	strNotice.AppendFormat(L"%s ~ \n",strStartTime );
	strNotice.AppendFormat(L"%s\n", strEndTime);
	strNotice.AppendFormat(L"%s", LoadStringFromResource(IDS_STRING625));
	strNotice.AppendFormat(L"%s", strReason);

	pDC->DrawText(strNotice, rcCheck, DT_LEFT|DT_NOPREFIX |DT_WORDBREAK);

	CRect rcNotice(0, 0, 0, 0);
	rcNotice.SetRect(20,220,355,355);
	pDC->SelectObject(&g_ftDefault13PX);
	pDC->SetTextColor(CHANGENOTICE_DLG_TEXT_BG_COLOR);
	pDC->DrawText(LoadStringFromResource(IDS_STRING615), rcNotice, DT_LEFT|DT_WORDBREAK);
	
	pDC->SetTextColor(oldColor);	
	pDC->SelectObject(pOldFont);

	pDC->SelectObject(pOldFont);


	rcTitle.SetRect(50,30,200,50);


	ASSERT(bmIcon);
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	CBitmap* oldBmp= memDC.SelectObject(bmIcon);
	pDC->BitBlt(20,24,20,19,&memDC,0,0,SRCCOPY);
	memDC.SelectObject(oldBmp);


	return TRUE;
}

void ChangeNoticeDlg::InitSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
	m_btnOk.SetFont(&g_ftDefault13PX);
	m_btnOk.MoveWindow(120, 357 - CHANGENOTICE_DLG_TITLEBAR_HEIGHT, 58, 28);
}

void ChangeNoticeDlg::OnBnClickedButtonOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	GET_APP()->m_pChangeNoticeDialogManager->Remove(this);
	this->DestroyWindow();
}

bool ChangeNoticeDlg::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	if( (pMsg->message == WM_CLOSE) ||
		(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE) || 
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) ||
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))
		result = true;

	return result;
}

BOOL ChangeNoticeDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
	}
	else if( IsCloseMsg(pMsg) )
	{
		GET_APP()->m_pChangeNoticeDialogManager->Remove(this);
		this->DestroyWindow();
		return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}
